<?php

require_once('base_controller.php');

/**
 * Copy many slaves from a master to another existing master
 */
class copy_slaves_controller extends base_controller {
	var $name = 'Clone';

	/**
	 * Add host's name to page name
	 */
	public function __construct($input) {
		parent::__construct($input);
		if ($input->master_obj_type && $input->master_obj_id) {
			$class = $input->master_obj_type.'_class';
			$obj = new $class($input->master_obj_id);
			$this->name .= ' '.$input->obj_type.'s from ' . $obj->get_object_name();
		}
		$this->input = $input;
	}

	/**
	 * Print service selector form
	 */
	public function index() {
		$input = $this->input;
		if (!$input->master_obj_type || !$input->master_obj_id) {
			echo "<p><strong>Ooops, you shouldn't be able to get here without an object type and id. Exiting.</strong></p>";
			exit(1);
		}
		$class = $input->master_obj_type.'_class';
		$obj = new $class($input->master_obj_id);
		$slave_tmp = get_objects_for_user($input->obj_type);
		$slave_objects = array();
		foreach ($slave_tmp as $slaveid => $_) {
			$slave_objects[$slaveid] = get_object_name_by_id($input->obj_type, $slaveid);
		}
		$excludes = array($input->master_obj_type => $input->master_obj_id);
		$slave_class = $input->obj_type.'_class';
		$slave_obj = new $slave_class();
		$candidates = array_keys($slave_obj->master_obj_candidates);
		$default_id = $input->obj_id;
		if ($default_id && $default_id != 'new')
			$default = array($default_id);
		else
			$default = array();
		require_once(dirname(__FILE__).'/../../templates/copy_slaves.php');
	}

	/**
	 * Do the actual copying
	 */
	public function do_clone() {
		$input = $this->input;
		global $page;
		$from_slaves = $input->get_array('from_slaves');
		$class = $input->obj_type.'_class';
		$success = array('all' => 0);
		if (is_array($from_slaves))
			foreach ($from_slaves as $sid) {
				$slave = new $class($sid);
				foreach ($input->selection as $type => $objs) {
					$slave = new $class($sid);
					$slave->set_master_object_type($type);
					foreach ($objs as $target_id) {
						$new_slave = $slave->clone_object();
						$new_slave->set_master_object_id($target_id);
						if (!$new_slave->save_object()) {
							echo "Couldn't save {$input->obj_type} {$new_slave->get_object_name()}:";
							$page->print_validation_error_table($new_slave);
						} else {
							$success[$type][$target_id] = 1;
							$success['all']++;
						}
					}
				}
			}
		echo '<p><img src="images/icons/shield-ok_16x16.png" alt="" style="margin-bottom: -3px" /> ';
		echo "<strong>Created {$success['all']} clones from ".count($from_slaves)." {$input->obj_type}s";
		unset($success['all']);
		if (!empty($success))
			echo " to ";
		$first = true;
		foreach ($success as $type => $ids) {
			if (!$first)
				echo ", ";
			echo count($ids).' '.$type.'s';
			$first = false;
		}
		echo "</strong></p>";
		echo '<p><a href="edit.php?obj_type='.$input->obj_type.'&amp;obj_id='.$input->obj_id.'">Back</a></p>';
		if (!empty($success))
			echo top_bar_class::add_unsaved_warning();
	}
}
