<?php

require_once('include/webconfig.inc.php');
require_once('include/config.inc.php');
require_once('classes/common_gui.php');
require_once('classes/object_class.php');

die_if_locked_hard();

$input = new input_class();

$path = $_SERVER['PATH_INFO'];
preg_match('/^\/([^\/]+)/', $path, $matches);
$page_name = $matches[1];
$action = $input->action;
$redirect_to_index = false;
if (!$action) {
	$action = 'index';

}
if(strtolower($action) == 'submit' && $_SERVER['REQUEST_METHOD'] != 'POST') {
	$redirect_to_index = true;
}

if (is_file('classes/controllers/'.$page_name.'.php')) {
	require_once('classes/controllers/'.$page_name.'.php');
	$classname = $page_name.'_controller';
	$obj = new $classname($input);
	if($redirect_to_index) {
		return base_controller::redirect($page_name, 'index');
	}
	if (isset($obj->name) && $obj->name) {
		$page->html_start($obj->name);
	} else {
		$page->html_start(ucwords($page_name));
	}
	$obj->$action();
} else {
	$location = dirname($_SERVER['SCRIPT_NAME']).$_SERVER['PATH_INFO'];
	if (isset($_SERVER['QUERY_STRING']))
		$location .= '?'.$_SERVER['QUERY_STRING'];
	header('Location: '.$location);
	exit(1);
}
$page->html_end();
