<?php
/**
 * Unit tests for the webconfiguration tool's object api
 *
 * The tests aim to:
 *   - include the code used by the webconfig tool itself
 *   - import objects from a single configuration file
 *   - insert those objects into a database
 *   - manipulate the objects, using the object API
 *   - undo all changes (ie, import again)
 *   - save the objects to a different file
 *   - compare the resulting files to ensure they are identical
 */
require_once('include/import.inc.php');
require_once('include/export.inc.php');

function fix_one($f)
{
	$defs = array
		('host_notifications_enabled' => 1,
		 'service_notifications_enabled' => 1,
		 'can_submit_commands' => 1,
		 'retain_status_information' => 1,
		 'retain_nonstatus_information' => 1,
		 );

	$obj_array = import_objects($f);
	if (!isset($obj_array['contact']))
		return;

	echo "  $f\n";
	foreach ($obj_array['contact'] as $id => $obj) {
		$notset = array();
		foreach ($defs as $k => $v) {
			if (!isset($obj[$k])) {
				$notset[$k] = $v;
			}
		}
		if (count($notset) == count($defs)) {
			foreach ($defs as $k => $v) {
				$obj[$k] = $v;
			}
		}
		$obj_array['contact'][$id] = $obj;
	}

	$glue_ary = false;
	foreach ($obj_array as $obj_type => $obj_list) {
		foreach ($obj_list as $obj) {
			$obj['obj_type'] = $obj_type;
			$glue_ary[] = $obj;
		}
	}

	write_file($f, glue_export($glue_ary));
}

echo "Fixing contact settings for backwards compatibility in\n";
$cfg_files = get_config_files();
foreach ($cfg_files as $f) {
	$obj_array = array();
	$index = array();
	fix_one($f);
}
