<?php
/*
 * Copyright(C) 2003-2005, 2007 op5 AB
 * All rights reserved.
 *
 */

$DEBUG = false;
$IMPORTING = false;

$Version = '4.5.2-op5.1';


$HOME		= '/opt/monitor/';
$DATADIR	= $HOME . 'op5/nacoma/data/';
$IMPORTDIR	= $HOME . 'op5/nacoma/imported/';
$COMMENTDIR = $IMPORTDIR . 'comments/';
$HOOKDIR    = $HOME . 'op5/nacoma/hooks/';

// ONLY this user is allowed to modify user access levels, as defined in
// $Config['cgi']. Contacts administration is a different matter.
$UserAdmin = false;

$Config['main']		= $HOME . 'etc/nagios.cfg';
$Config['cgi']		= $HOME . 'etc/cgi.cfg';

$SUPPORT = "<a href='mailto:support@op5.se?subject=Webconfig'>support@op5.se</a>";

$Backup_Config_Dir = "/tmp/nacoma-conf-backup/";

$Supported_Object_Types =
  array('contact',
		'contactgroup',
		'hostgroup',
		'host',
		'service',
		'servicegroup',
		'timeperiod',
		'command',
		'servicedependency',
		'serviceescalation',
		'hostdependency',
		'hostescalation',
		'FILE'
		);

$show_logserver_scan = true;

define("CUSTOM_CONFIG", dirname(__FILE__)."/../custom_config.php");

# variables settable from the CUSTOM_CONFIG files
$notouch_files = array();
$notouch_file_prefix = false;
$notouch_dir_prefix = false;
if (is_file(CUSTOM_CONFIG) && is_readable(CUSTOM_CONFIG))
	require_once(CUSTOM_CONFIG);

require_once('op5/log.php');
require_once('op5/auth/Auth.php');
require_once('op5/auth/Authorization.php');
$op5_auth = Op5Auth::instance();

if (!isset($webconfig_user))
	$webconfig_user = false;

function give_infinite_rights()
{
	global $webconfig_user;
	set_user('superuser');
	require_once('op5/auth/Authorization.php');
	foreach (array_reduce(Op5Authorization::get_all_auth_levels(), function($a, $b) {return array_merge($a, array_keys($b));}, array()) as $value) {
		$auth_data[$value] = true;
	}
	$webconfig_user->auth_data = $auth_data;
}

/**
 * Sets the username that other functions can
 * later use to get the name of the logged-in
 * user.
 */
function set_user($user, $groups = array())
{
	global $webconfig_user;
	global $Objects_For_User;
	global $op5_auth;
	global $console_access;
	$op5_auth->force_user(new Op5User(array("username" => $user, "groups" => $groups)));
	$webconfig_user = $op5_auth->get_user();
	$Objects_For_User = array();
}

/**
 * Retrieves the username as either set by the
 * set_user() function, or as determined by the
 * environment or insn.
 *
 * @return string username
 */
function get_user()
{
	global $webconfig_user, $console_access;
	global $op5_auth;

	if (!$webconfig_user) {
		if (PHP_SAPI === 'cli') {
			if ($console_access === true) {
				/* FIXME: Rights */
				$op5_auth->force_user(new Op5User_AlwaysAuth());
				$webconfig_user = $op5_auth->get_user();
			} else {
				$ary = posix_getpwuid(posix_geteuid());
				/* FIXME: Rights */
				$webconfig_user = new Op5User( array( 'username' => $ary['name'] ) );
			}
		} else {
			# might be called from ninja
			@session_name('ninjasession');
			@session_start();
			$webconfig_user = $op5_auth->get_user();
		}
	}

	return $webconfig_user->username;
}

/**
 * @return string current version number, or empty if version file cannot be found
 */
function monitor_version() {
	if(!@is_readable('/etc/op5-monitor-release')) {
		return "";
	}
	return trim(preg_replace('/^VERSION=/', null, file_get_contents('/etc/op5-monitor-release')));
}
