<?php
require_once('object_class.php');

/**
 * Commands are executed on each check and consists of
 * a program and it's command line arguments.
 */
class command_class extends object_class
{
	/** object type */
	static $type = 'command';

	/**
	 * Prepare an object for drawing in the gui
	 */
	function prepare_draw()
	{
		parent::prepare_draw();

		if (!$this->topic)
		  $this->topic = $this->obj['command_name'];

		if (!$this->id) {
			$this->id = 'new';
		}

		if ($this->id === 'new') {
			$this->topic = 'New ' . $this->type;
		}

		foreach ($this->properties['var_index'] as $k => $discard) {
			if (!isset($this->obj[$k]))
			  $this->obj[$k] = '';
		}
	}
	
	/**
	 * Export with naming and values to map nagios struct names ond format
	 * 
	 * Useful for Test this x operation
	 */
	public function get_nagios_struct($prefix='') {
		$this->expand_object();
		$obj = $this->denormalize();
		return array(
				$prefix . 'name' => $obj['command_name'],
				$prefix . 'command_line' => $obj['command_line'],
				);
	}
}
