<?php
require_once('host_class.php');

/**
 * A host template is used for inheritance, so that you could
 * base your hosts with common properties on one of these.
 */
class host_template_class extends host_class
{
	/** object type */
	static $type = 'host_template';
	/** template or not? */
	var $is_template = true;
	/** database table to use */
	var $db_table = 'host';
	/** default settings for new objects */
	var $def_new_obj =
	  array('name' => '',
			'check_command' => 'check-host-alive',
			'check_command_args' => '',
			'contact_groups' => '',
			'max_check_attempts' => '5',
			'active_checks_enabled' => '1',
			'passive_checks_enabled' => '1',
			'event_handler' => '',
			'event_handler_enabled' => '1',
			'low_flap_threshold' => '',
			'high_flap_threshold' => '',
			'flap_detection_enabled' => '1',
			'process_perf_data' => '1',
			'retain_status_information' => '1',
			'retain_nonstatus_information' => '1',
			'notification_interval' => '0',
			'first_notification_delay' => '',
			'notification_period' => '24x7',
			'notification_options' => 'd,u,r,f',
			'notifications_enabled' => '1',
			'stalking_options' => 'n',
			'register' => '0',
			'file_id' => 'etc/hosts.cfg'
			);
	var $slave_types=false;

	function get_properties()
	{
		$this->properties = get_object_properties('host');
		$this->properties['var_index'] = array_merge(array('name' => 'string'), $this->properties['var_index']);
		$this->properties['default'] = $this->def_new_obj;
		$this->properties['topic'] = 'name';
		unset($this->properties['var_index']['host_name']);
		unset($this->properties['var_index']['alias']);
		unset($this->properties['var_index']['address']);
		$this->properties['required'] = array('name');
		return $this->properties;
	}

	/**
	 * Prepare the object for drawing in the gui
	 */
	function prepare_draw()
	{
		parent::prepare_draw();

		$this->expand_object();
	}

	public function get_cmd_bar_links()
	{
		$cmd_links = parent::get_cmd_bar_links();
		unset($cmd_links['clone']);
		return $cmd_links;
	}
}
