<?php
require_once('object_class.php');

/**
 * A host group definition is used to group one or more hosts together for
 * simplifying configuration.
 */
class hostgroup_class extends object_class
{
	/** object type */
	static $type = 'hostgroup';
	var $slave_types = array(
		'service',
		'hostdependency',
		'hostescalation',
	);

	protected function get_reasons_to_not_delete(&$all, &$hard)
	{
		parent::get_reasons_to_not_delete($all, $hard);
		$res = pdo_exec_query('SELECT id FROM management_pack WHERE hostgroup = '.pdo_quote_string($this->obj[$this->properties['topic']]));
		foreach ($res as $row) {
			if (!isset($hard['management_pack']))
				$hard['management_pack'] = array();
			$hard['management_pack'][$row[0]] = $row[0];
		}
		if (isset($hard['management_pack']))
			$all['management_pack'] = $hard['management_pack'];
		unset($res);
	}

	public function save_object($user=true)
	{
		$pre_name = get_object_name_by_id($this->type, $this->id);
		$post_name = $this->get_object_name();
		if (!parent::save_object($user))
			return false;
		if ($pre_name == $post_name)
			return true;
		pdo_exec_query('UPDATE management_pack SET hostgroup = '.pdo_quote_string($post_name).' WHERE hostgroup = '.pdo_quote_string($pre_name));
		return true;
	}
}
