<?php
require_once('object_class.php');

/**
 * Assign purposes to hostgroups
 *
 * When you've designed hostgroups with assigned services,
 * this will allow you to provide a user-friendly
 * description to help your users pick out good ones.
 */
class management_pack_class extends object_class
{
	public $properties = array(
		'var_index' => array(
			'management_pack_name' => 'string',
			'hostgroup' => 'select',
			'icon' => 'image',
			'description' => 'textarea',
			'version' => 'int',
			'vendor' => 'string',
		),
		'widget' => array(
			'version' => 'hidden',
			'vendor' => 'hidden',
		),
		'required' => array(
			'management_pack_name',
			'hostgroup',
			'icon',
			'description'
		),
		'default' => array(),
		'special' => array(
			'hostgroup' => array(),
			'icon' => array(),
		),
		'topic' => 'management_pack_name',
	);

	public static $type = 'management_pack';

	function get_properties()
	{
		$img_list = glob("/opt/monitor/op5/ninja/application/media/images/logos/*");
		foreach($img_list as $img)
			$this->properties['special']['icon'][basename($img)] = basename($img);
		foreach (get_object_index_table('hostgroup') as $obj) {
			$this->properties['special']['hostgroup'][$obj] = $obj;
		}
		return $this->properties;
	}

	function update_changelog($action = false)
	{
		// No changelog for management packs, because they only live in the database
	}
}
