<?php
require_once('service_class.php');

/**
 * A service template is used for inheritance, so that you could
 * base your services with common properties on one of these.
 */
class service_template_class extends service_class
{
	/** object type */
	static $type = 'service_template';
	/** template or not? */
	var $is_template = true;
	/** database table to use */
	var $db_table = 'service';
	/** Variable in this object identifying the master object (ie, none) */
	var $master_obj_identifier = false;
	/** default settings for new service templates */
	var $def_new_obj =
	  array('name' => '',
			'is_volatile' => '',
			'check_command' => 'check_ping',
			'check_command_args' => '',
			'max_check_attempts' => '3',
			'check_interval' => '5',
			'retry_interval' => '1',
			'active_checks_enabled' => '1',
			'passive_checks_enabled' => '1',
			'check_period' => '24x7',
			'parallelize_check' => '1',
			'obsess' => '1',
			'check_freshness' => '0',
			'freshness_threshold' => '',
			'event_handler' => '',
			'event_handler_enabled' => '1',
			'low_flap_threshold' => '',
			'high_flap_threshold' => '',
			'flap_detection_enabled' => '1',
			'process_perf_data' => '1',
			'retain_status_information' => '1',
			'retain_nonstatus_information' => '1',
			'notification_interval' => '0',
			'notification_period' => '24x7',
			'notification_options' => 'c,w,u,r,f',
			'notifications_enabled' => '1',
			'contact_groups' => '',
			'stalking_options' => 'n',
			'register' => '0',
			'file_id' => 'etc/services.cfg'
			);
	var $slave_types = false;

	/**
	 * All template classes need to have their own constructor,
	 * but we can still borrow the parent class constructor
	 * for most of our work.
	 */
	function __construct($id = false)
	{
		$this->master_obj_type = false;
		$this->master_obj_id = false;
		parent::__construct($id);
	}

	function get_properties()
	{
		$this->properties = get_object_properties('service');
		$this->properties['default'] = $this->def_new_obj;
		$this->properties['topic'] = 'name';
		$this->properties['required'] = array('name');
		$this->properties['var_index'] = array_merge(array('name' => 'string'), $this->properties['var_index']);
		unset($this->properties['var_index']['service_description']);
		return $this->properties;
	}

	/**
	 * Prepare an object for drawing in the gui
	 */
	function prepare_draw()
	{
		parent::prepare_draw();

		$this->expand_object();
		unset($this->obj['host_name']);
		unset($this->obj['service_description']);
	}

	public function get_cmd_bar_links()
	{
		$cmd_links = parent::get_cmd_bar_links();
		unset($cmd_links['clone']);
		return $cmd_links;
	}
}
