<?php
require_once('extinfo_class.php');

/**
 * Serviceextinfo-related methods and variables
 */
class serviceextinfo_class extends extinfo_class
{
	/** object type */
	static $type 					= 'serviceextinfo';
	/** master object type */
	var $master_obj_type        = 'service';
	/** Variable in this object identifying the master object */
	var $master_obj_identifier 	= 'service';

	/**
	 * Prepare an object for drawing in the gui
	 */
	function prepare_draw()
	{
		$idx = get_object_index_table('service');
		$topic = "Extended Serviceinfo Configuration ";
		parent::prepare_draw();

		if (!$this->id) {
			$this->id = 'new';
		}

		$this->topic = $this->id==='new' ? "New " . $topic : $topic;
		if ($this->master_obj_id && isset($idx[$this->master_obj_id])) {
			$host_service = explode(';', $idx[$this->master_obj_id]);
			if (is_array($host_service) && sizeof($host_service)==2){
				$host 		= $host_service[0];
				$service 	= $host_service[1];
				$this->topic .= "for service '".$service."' on host '".$host."'";
			} else {
				$this->topic .= " " . $idx[$this->master_obj_id];
			}
		}
	}
}
