DROP SEQUENCE autoscan_join_id_SEQ;
CREATE SEQUENCE  autoscan_join_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE autoscan_results_id_SEQ;
CREATE SEQUENCE  autoscan_results_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE command_id_SEQ;
CREATE SEQUENCE  command_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE FILE_tbl_id_SEQ;
CREATE SEQUENCE  FILE_tbl_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE service_id_SEQ;
CREATE SEQUENCE  service_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE serviceescalation_id_SEQ;
CREATE SEQUENCE  serviceescalation_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE contact_id_SEQ;
CREATE SEQUENCE  contact_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE contactgroup_id_SEQ;
CREATE SEQUENCE  contactgroup_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE host_id_SEQ;
CREATE SEQUENCE  host_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE servicedependency_id_SEQ;
CREATE SEQUENCE  servicedependency_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE servicegroup_id_SEQ;
CREATE SEQUENCE  servicegroup_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE hostescalation_id_SEQ;
CREATE SEQUENCE  hostescalation_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE autoscan_settings_id_SEQ;
CREATE SEQUENCE  autoscan_settings_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE autoscan_blacklist_id_SEQ;
CREATE SEQUENCE  autoscan_blacklist_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE changelog_id_SEQ;
CREATE SEQUENCE  changelog_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;


DROP SEQUENCE objlocks_id_SEQ;
CREATE SEQUENCE  objlocks_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE hostdependency_id_SEQ;
CREATE SEQUENCE  hostdependency_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;

DROP SEQUENCE timeperiod_id_SEQ;
CREATE SEQUENCE  timeperiod_id_SEQ
  MINVALUE 1 MAXVALUE 999999999999999999999999 INCREMENT BY 1  NOCYCLE ;


DROP TABLE contact_access CASCADE CONSTRAINTS;
CREATE TABLE contact_access (
  contact INT NOT NULL,
  host INT DEFAULT NULL,
  service INT DEFAULT NULL
);
CREATE INDEX contact_service ON contact_access(contact, service);
CREATE INDEX contact_host ON contact_access(contact, host);

DROP TABLE action_log CASCADE CONSTRAINTS;
CREATE TABLE action_log (
  username VARCHAR2(30 CHAR) NOT NULL,
  action VARCHAR2(50 CHAR) NOT NULL,
  time DATE DEFAULT SYSDATE NOT NULL
);



DROP TABLE autoscan_join CASCADE CONSTRAINTS;
CREATE TABLE autoscan_join (
  id NUMBER(10,0) NOT NULL,
  scan NUMBER(10,0) NOT NULL,
  host NUMBER(10,0) NOT NULL,
  epoch NUMBER(10,0) NOT NULL
);
ALTER TABLE autoscan_join ADD CONSTRAINT PRIMARY_21 PRIMARY KEY(id) ENABLE;

DROP TABLE autoscan_results CASCADE CONSTRAINTS;
CREATE TABLE autoscan_results (
  id NUMBER(10,0) NOT NULL,
  address VARCHAR2(255 CHAR) NOT NULL,
  name VARCHAR2(255 CHAR) NOT NULL,
  refs NUMBER(10,0) NOT NULL,
  visibility NUMBER(3,0) NOT NULL
);
ALTER TABLE autoscan_results ADD CONSTRAINT PRIMARY_1 PRIMARY KEY(id) ENABLE;

DROP TABLE autoscan_settings CASCADE CONSTRAINTS;
CREATE TABLE autoscan_settings (
  id NUMBER(10,0) NOT NULL,
  count NUMBER(10,0) NOT NULL,
  epoch NUMBER(10,0) NOT NULL,
  criteria CLOB NOT NULL,
  name CLOB NOT NULL,
  description CLOB,
  enabled NUMBER(3,0) NOT NULL
);
ALTER TABLE autoscan_settings ADD CONSTRAINT PRIMARY_8 PRIMARY KEY(id) ENABLE;

DROP TABLE autoscan_blacklist CASCADE CONSTRAINTS;
CREATE TABLE autoscan_blacklist (
  id NUMBER(10,0) NOT NULL,
  address VARCHAR(255 CHAR) NOT NULL
);
ALTER TABLE autoscan_blacklist ADD CONSTRAINT PRIMARY_22 PRIMARY KEY(id) ENABLE;

DROP TABLE changelog CASCADE CONSTRAINTS;
CREATE TABLE changelog (
  id NUMBER(10,0) NOT NULL,
  object_type VARCHAR2(100 CHAR) NOT NULL,
  object_id NUMBER(10,0) NOT NULL,
  oldname VARCHAR2(255 CHAR) DEFAULT NULL,
  newname VARCHAR2(255 CHAR) DEFAULT NULL,
  oldstate CLOB DEFAULT NULL,
  newstate CLOB DEFAULT NULL,
  username VARCHAR2(255 CHAR),
  time DATE DEFAULT SYSDATE
);
ALTER TABLE changelog ADD CONSTRAINT PRIMARY PRIMARY KEY(id) ENABLE;
CREATE INDEX object_type_1 ON changelog(object_type);

DROP TABLE objlocks CASCADE CONSTRAINTS;
CREATE TABLE objlocks (
  id NUMBER(10,0) NOT NULL,
  object_type VARCHAR2(100 CHAR) NOT NULL,
  object_id NUMBER(10,0) NOT NULL,
  username VARCHAR2(255 CHAR),
  time NUMBER(10,0) NOT NULL
);
ALTER TABLE objlocks ADD CONSTRAINT PRIMARY_23 PRIMARY KEY(id) ENABLE;
CREATE INDEX object_type_2 ON objlocks(object_type);
CREATE INDEX object_id_1 ON objlocks(object_id);

DROP TABLE command CASCADE CONSTRAINTS;
CREATE TABLE command (
  id NUMBER(10,0) NOT NULL,
  command_name VARCHAR2(255 CHAR) NOT NULL,
  command_line CLOB NOT NULL,
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE command ADD CONSTRAINT PRIMARY_17 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX command_name ON command(command_name);

DROP TABLE contact CASCADE CONSTRAINTS;
CREATE TABLE contact (
  id NUMBER(10,0) NOT NULL,
  contact_name VARCHAR2(255 CHAR),
  alias VARCHAR2(255 CHAR) DEFAULT NULL,
  host_notifications_enabled NUMBER(3,0),
  service_notifications_enabled NUMBER(3,0),
  can_submit_commands NUMBER(3,0),
  retain_status_information NUMBER(3,0),
  retain_nonstatus_information NUMBER(3,0),
  host_notification_period NUMBER(10,0),
  service_notification_period NUMBER(10,0),
  host_notification_options VARCHAR2(15 CHAR),
  service_notification_options VARCHAR2(15 CHAR),
  host_notification_cmds NUMBER(10,0),
  host_notification_cmds_args CLOB,
  service_notification_cmds NUMBER(10,0),
  service_notification_cmds_args CLOB,
  email VARCHAR2(255 CHAR),
  pager VARCHAR2(100 CHAR),
  address1 VARCHAR2(100 CHAR),
  address2 VARCHAR2(100 CHAR),
  address3 VARCHAR2(100 CHAR),
  address4 VARCHAR2(100 CHAR),
  address5 VARCHAR2(100 CHAR),
  address6 VARCHAR2(100 CHAR),
  minimum_value NUMBER(10,0),
  register NUMBER(3,0) DEFAULT '1',
  name VARCHAR2(75 CHAR),
  template NUMBER(10,0),
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE contact ADD CONSTRAINT PRIMARY_20 PRIMARY KEY(id) ENABLE;
CREATE INDEX contact_name ON contact(contact_name);

DROP TABLE contact_contactgroup CASCADE CONSTRAINTS;
CREATE TABLE contact_contactgroup (
  contact NUMBER(10,0) NOT NULL,
  contactgroup NUMBER(10,0) NOT NULL
);

DROP TABLE contactgroup CASCADE CONSTRAINTS;
CREATE TABLE contactgroup (
  id NUMBER(10,0) NOT NULL,
  contactgroup_name VARCHAR2(255 CHAR) NOT NULL,
  alias VARCHAR2(255 CHAR) NOT NULL,
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE contactgroup ADD CONSTRAINT PRIMARY_16 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX contactgroup_name ON contactgroup(contactgroup_name);

DROP TABLE contactgroup_members CASCADE CONSTRAINTS;
CREATE TABLE contactgroup_members (
  contactgroup NUMBER(10,0) NOT NULL,
  members NUMBER(10,0) NOT NULL
);


DROP TABLE hostgroup_members CASCADE CONSTRAINTS;
CREATE TABLE hostgroup_members (
  hostgroup NUMBER(10,0) NOT NULL,
  members NUMBER(10,0) NOT NULL
);


DROP TABLE servicegroup_members CASCADE CONSTRAINTS;
CREATE TABLE servicegroup_members (
  servicegroup NUMBER(10,0) NOT NULL,
  members NUMBER(10,0) NOT NULL
);


DROP TABLE custom_vars CASCADE CONSTRAINTS;
CREATE TABLE custom_vars (
  obj_type VARCHAR2(30 CHAR) NOT NULL,
  obj_id NUMBER(10,0) NOT NULL,
  variable VARCHAR2(255 CHAR),
  value VARCHAR2(255 CHAR)
);
CREATE UNIQUE INDEX objvar ON custom_vars(obj_type, obj_id, variable);

DROP TABLE FILE_tbl CASCADE CONSTRAINTS;
CREATE TABLE FILE_tbl (
  id NUMBER(10,0) NOT NULL,
  FILE_name VARCHAR2(255 CHAR) NOT NULL
);
ALTER TABLE FILE_tbl ADD CONSTRAINT PRIMARY_15 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX FILE_name ON FILE_tbl(FILE_name);

DROP TABLE host CASCADE CONSTRAINTS;
CREATE TABLE host (
  id NUMBER(10,0) NOT NULL,
  host_name VARCHAR2(255 CHAR),
  alias VARCHAR2(100 CHAR) DEFAULT NULL,
  display_name VARCHAR2(100 CHAR),
  address VARCHAR2(75 CHAR) DEFAULT '', --  was: NOT NULL, but this breaks existing app logic
  initial_state VARCHAR2(18 CHAR),
  check_command NUMBER(10,0),
  check_command_args CLOB,
  max_check_attempts NUMBER(5,0),
  check_interval NUMBER(5,0),
  retry_interval NUMBER(5,0),
  active_checks_enabled NUMBER(3,0),
  passive_checks_enabled NUMBER(3,0),
  check_period NUMBER(10,0),
  obsess NUMBER(3,0),
  check_freshness NUMBER(3,0),
  freshness_threshold FLOAT,
  event_handler NUMBER(10,0),
  event_handler_args CLOB,
  event_handler_enabled NUMBER(3,0),
  low_flap_threshold FLOAT,
  high_flap_threshold FLOAT,
  flap_detection_enabled NUMBER(3,0),
  flap_detection_options VARCHAR2(18 CHAR),
  process_perf_data NUMBER(3,0),
  retain_status_information NUMBER(3,0),
  retain_nonstatus_information NUMBER(3,0),
  notification_interval NUMBER(12,0),
  first_notification_delay NUMBER(10,0),
  notification_period NUMBER(10,0),
  notification_options VARCHAR2(15 CHAR),
  notifications_enabled NUMBER(3,0),
  stalking_options VARCHAR2(15 CHAR),
  notes VARCHAR2(255 CHAR),
  notes_url VARCHAR2(255 CHAR),
  action_url VARCHAR2(255 CHAR),
  icon_image VARCHAR2(255 CHAR),
  icon_image_alt VARCHAR2(255 CHAR),
  statusmap_image VARCHAR2(255 CHAR),
  A2d_coords VARCHAR2(20 CHAR),
  hourly_value NUMBER(10,0),
  name VARCHAR2(75 CHAR),
  template NUMBER(10,0),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE host ADD CONSTRAINT PRIMARY_7 PRIMARY KEY(id) ENABLE;
CREATE INDEX host_name ON host(host_name);

DROP TABLE host_contact CASCADE CONSTRAINTS;
CREATE TABLE host_contact (
  host NUMBER(10,0) NOT NULL,
  contact NUMBER(10,0) NOT NULL
);

DROP TABLE host_contactgroup CASCADE CONSTRAINTS;
CREATE TABLE host_contactgroup (
  host NUMBER(10,0) NOT NULL,
  contactgroup NUMBER(10,0) NOT NULL
);

DROP TABLE host_hostgroup CASCADE CONSTRAINTS;
CREATE TABLE host_hostgroup (
  host NUMBER(10,0) NOT NULL,
  hostgroup NUMBER(10,0) NOT NULL
);

DROP TABLE host_parents CASCADE CONSTRAINTS;
CREATE TABLE host_parents (
  host NUMBER(10,0) NOT NULL,
  parents NUMBER(10,0) NOT NULL
);

DROP TABLE hostdependency CASCADE CONSTRAINTS;
CREATE TABLE hostdependency (
  id NUMBER(10,0) NOT NULL,
  host_name NUMBER(10,0),
  hostgroup_name NUMBER(10,0),
  dependent_host_name NUMBER(10,0),
  dependent_hostgroup_name NUMBER(10,0),
  dependency_period NUMBER(10,0),
  inherits_parent NUMBER(3,0),
  execution_failure_criteria VARCHAR2(15 CHAR),
  notification_failure_criteria VARCHAR2(15 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE hostdependency ADD CONSTRAINT PRIMARY_5 PRIMARY KEY(id) ENABLE;

DROP TABLE hostescalation CASCADE CONSTRAINTS;
CREATE TABLE hostescalation (
  id NUMBER(10,0) NOT NULL,
  host_name NUMBER(10,0),
  hostgroup_name NUMBER(10,0),
  first_notification NUMBER(10,0),
  last_notification NUMBER(10,0),
  notification_interval NUMBER(10,0),
  escalation_period NUMBER(10,0),
  escalation_options VARCHAR2(15 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE hostescalation ADD CONSTRAINT PRIMARY_19 PRIMARY KEY(id) ENABLE;

DROP TABLE hostescalation_contact CASCADE CONSTRAINTS;
CREATE TABLE hostescalation_contact (
  hostescalation NUMBER(10,0) NOT NULL,
  contact NUMBER(10,0) NOT NULL
);

DROP TABLE hostescalation_contactgroup CASCADE CONSTRAINTS;
CREATE TABLE hostescalation_contactgroup (
  hostescalation NUMBER(10,0) NOT NULL,
  contactgroup NUMBER(10,0) NOT NULL
);

DROP TABLE hostextinfo CASCADE CONSTRAINTS;
CREATE TABLE hostextinfo (
  id NUMBER(10,0) NOT NULL,
  host_name NUMBER(10,0) NOT NULL,
  notes VARCHAR2(255 CHAR),
  notes_url VARCHAR2(255 CHAR),
  action_url VARCHAR2(255 CHAR),
  icon_image VARCHAR2(255 CHAR),
  icon_image_alt VARCHAR2(255 CHAR),
  statusmap_image VARCHAR2(255 CHAR),
  A2d_coords VARCHAR2(20 CHAR),
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE hostextinfo ADD CONSTRAINT PRIMARY_12 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX host_name_1 ON hostextinfo(host_name);

DROP TABLE hostgroup CASCADE CONSTRAINTS;
CREATE TABLE hostgroup (
  id NUMBER(10,0) NOT NULL,
  hostgroup_name VARCHAR2(255 CHAR),
  alias VARCHAR2(255 CHAR),
  notes VARCHAR2(255 CHAR),
  notes_url VARCHAR2(255 CHAR),
  action_url VARCHAR2(255 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE hostgroup ADD CONSTRAINT PRIMARY_4 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX hostgroup_name ON hostgroup(hostgroup_name);

DROP TABLE service CASCADE CONSTRAINTS;
CREATE TABLE service (
  id NUMBER(10,0) NOT NULL,
  host_name NUMBER(10,0) DEFAULT NULL,
  hostgroup_name NUMBER(10,0) DEFAULT NULL,
  service_description VARCHAR2(255 CHAR) DEFAULT NULL, -- was: NOT NULL, but that breaks app logic
  display_name VARCHAR2(255 CHAR),
  is_volatile NUMBER(3,0),
  check_command NUMBER(10,0),
  check_command_args CLOB,
  initial_state VARCHAR2(1 CHAR),
  max_check_attempts NUMBER(5,0),
  check_interval NUMBER(5,0),
  retry_interval NUMBER(5,0),
  active_checks_enabled NUMBER(3,0),
  passive_checks_enabled NUMBER(3,0),
  check_period NUMBER(10,0),
  parallelize_check NUMBER(3,0),
  obsess NUMBER(3,0),
  check_freshness NUMBER(3,0),
  freshness_threshold NUMBER(10,0),
  event_handler NUMBER(10,0),
  event_handler_args CLOB,
  event_handler_enabled NUMBER(3,0),
  low_flap_threshold FLOAT,
  high_flap_threshold FLOAT,
  flap_detection_enabled NUMBER(3,0),
  flap_detection_options VARCHAR2(18 CHAR),
  process_perf_data NUMBER(3,0),
  retain_status_information NUMBER(3,0),
  retain_nonstatus_information NUMBER(3,0),
  notification_interval NUMBER(10,0),
  first_notification_delay NUMBER(10,0),
  notification_period NUMBER(10,0),
  notification_options VARCHAR2(15 CHAR),
  notifications_enabled NUMBER(3,0),
  stalking_options VARCHAR2(15 CHAR),
  notes VARCHAR2(255 CHAR),
  notes_url VARCHAR2(255 CHAR),
  action_url VARCHAR2(255 CHAR),
  icon_image VARCHAR2(255 CHAR),
  icon_image_alt VARCHAR2(255 CHAR),
  hourly_value NUMBER(10,0),
  template NUMBER(10,0),
  name VARCHAR2(75 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE service ADD CONSTRAINT PRIMARY_18 PRIMARY KEY(id) ENABLE;
CREATE INDEX host_service_id ON service(host_name, service_description);
CREATE INDEX hostgroup_service_id ON service(hostgroup_name, service_description);

DROP TABLE service_contact CASCADE CONSTRAINTS;
CREATE TABLE service_contact (
  service NUMBER(10,0) NOT NULL,
  contact NUMBER(10,0) NOT NULL
);

DROP TABLE service_contactgroup CASCADE CONSTRAINTS;
CREATE TABLE service_contactgroup (
  service NUMBER(10,0) NOT NULL,
  contactgroup NUMBER(10,0) NOT NULL
);

DROP TABLE service_servicegroup CASCADE CONSTRAINTS;
CREATE TABLE service_servicegroup (
  service NUMBER(10,0) NOT NULL,
  servicegroup NUMBER(10,0) NOT NULL
);

DROP TABLE servicedependency CASCADE CONSTRAINTS;
CREATE TABLE servicedependency (
  id NUMBER(10,0) NOT NULL,
  service NUMBER(10,0) NOT NULL,
  dependent_service NUMBER(10,0) NOT NULL,
  dependency_period NUMBER(10,0),
  inherits_parent NUMBER(3,0),
  execution_failure_criteria VARCHAR2(15 CHAR),
  notification_failure_criteria VARCHAR2(15 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE servicedependency ADD CONSTRAINT PRIMARY_6 PRIMARY KEY(id) ENABLE;
CREATE INDEX service_1 ON servicedependency(service);
CREATE INDEX dependent_service ON servicedependency(dependent_service);

DROP TABLE serviceescalation CASCADE CONSTRAINTS;
CREATE TABLE serviceescalation (
  id NUMBER(10,0) NOT NULL,
  service NUMBER(10,0) NOT NULL,
  first_notification NUMBER(12,0),
  last_notification NUMBER(12,0),
  notification_interval NUMBER(12,0),
  escalation_period NUMBER(10,0),
  escalation_options VARCHAR2(15 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE serviceescalation ADD CONSTRAINT PRIMARY_10 PRIMARY KEY(id) ENABLE;

DROP TABLE serviceescalation_contact CASCADE CONSTRAINTS;
CREATE TABLE serviceescalation_contact (
  serviceescalation NUMBER(10,0) NOT NULL,
  contact NUMBER(10,0) NOT NULL
);

DROP TABLE serviceescalation_contactgroup CASCADE CONSTRAINTS;
CREATE TABLE serviceescalation_contactgroup (
  serviceescalation NUMBER(10,0) NOT NULL,
  contactgroup NUMBER(10,0) NOT NULL
);

DROP TABLE serviceextinfo CASCADE CONSTRAINTS;
CREATE TABLE serviceextinfo (
  id NUMBER(10,0) NOT NULL,
  service NUMBER(10,0) NOT NULL,
  notes VARCHAR2(255 CHAR),
  notes_url VARCHAR2(255 CHAR),
  action_url VARCHAR2(255 CHAR),
  icon_image VARCHAR2(255 CHAR),
  icon_image_alt VARCHAR2(255 CHAR),
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE serviceextinfo ADD CONSTRAINT PRIMARY_14 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX service ON serviceextinfo(service);

DROP TABLE servicegroup CASCADE CONSTRAINTS;
CREATE TABLE servicegroup (
  id NUMBER(10,0) NOT NULL,
  servicegroup_name VARCHAR2(255 CHAR) NOT NULL,
  alias VARCHAR2(255 CHAR) NOT NULL,
  notes VARCHAR2(255 CHAR),
  notes_url VARCHAR2(255 CHAR),
  action_url VARCHAR2(255 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE servicegroup ADD CONSTRAINT PRIMARY_13 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX servicegroup_name ON servicegroup(servicegroup_name);

DROP TABLE timeperiod CASCADE CONSTRAINTS;
CREATE TABLE timeperiod (
  id NUMBER(10,0) NOT NULL,
  timeperiod_name VARCHAR2(255 CHAR) NOT NULL,
  alias VARCHAR2(255 CHAR) NOT NULL,
  sunday VARCHAR2(255 CHAR),
  monday VARCHAR2(255 CHAR),
  tuesday VARCHAR2(255 CHAR),
  wednesday VARCHAR2(255 CHAR),
  thursday VARCHAR2(255 CHAR),
  friday VARCHAR2(255 CHAR),
  saturday VARCHAR2(255 CHAR),
  register NUMBER(3,0) DEFAULT '1',
  FILE_id NUMBER(10,0) NOT NULL
);
ALTER TABLE timeperiod ADD CONSTRAINT PRIMARY_9 PRIMARY KEY(id) ENABLE;
CREATE UNIQUE INDEX timeperiod_name ON timeperiod(timeperiod_name);

DROP TABLE timeperiod_exclude CASCADE CONSTRAINTS;
CREATE TABLE timeperiod_exclude (
  timeperiod NUMBER(10,0) NOT NULL,
  exclude NUMBER(10,0) NOT NULL
);


CREATE OR REPLACE TRIGGER autoscan_join_id_TRG BEFORE INSERT OR UPDATE ON autoscan_join
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  autoscan_join_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM autoscan_join;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT autoscan_join_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER autoscan_blacklist_id_TRG BEFORE INSERT OR UPDATE ON autoscan_blacklist
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  autoscan_blacklist_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM autoscan_blacklist;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT autoscan_blacklist_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER autoscan_results_id_TRG BEFORE INSERT OR UPDATE ON autoscan_results
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  autoscan_results_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM autoscan_results;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT autoscan_results_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER command_id_TRG BEFORE INSERT OR UPDATE ON command
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  command_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM command;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT command_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER FILE_tbl_id_TRG BEFORE INSERT OR UPDATE ON FILE_tbl
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  FILE_tbl_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM FILE_tbl;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT FILE_tbl_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER service_id_TRG BEFORE INSERT OR UPDATE ON service
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  service_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM service;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT service_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER serviceescalation_id_TRG BEFORE INSERT OR UPDATE ON serviceescalation
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  serviceescalation_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM serviceescalation;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT serviceescalation_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER contact_id_TRG BEFORE INSERT OR UPDATE ON contact
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  contact_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM contact;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT contact_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER contactgroup_id_TRG BEFORE INSERT OR UPDATE ON contactgroup
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  contactgroup_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM contactgroup;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT contactgroup_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER host_id_TRG BEFORE INSERT OR UPDATE ON host
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  host_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM host;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT host_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER servicedependency_id_TRG BEFORE INSERT OR UPDATE ON servicedependency
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  servicedependency_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM servicedependency;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT servicedependency_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER servicegroup_id_TRG BEFORE INSERT OR UPDATE ON servicegroup
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  servicegroup_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM servicegroup;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT servicegroup_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER hostescalation_id_TRG BEFORE INSERT OR UPDATE ON hostescalation
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  hostescalation_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM hostescalation;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT hostescalation_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER autoscan_settings_id_TRG BEFORE INSERT OR UPDATE ON autoscan_settings
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  autoscan_settings_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM autoscan_settings;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT autoscan_settings_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER changelog_id_TRG BEFORE INSERT OR UPDATE ON changelog
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  changelog_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM changelog;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT changelog_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER objlocks_id_TRG BEFORE INSERT OR UPDATE ON objlocks
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  objlocks_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM objlocks;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT objlocks_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER hostdependency_id_TRG BEFORE INSERT OR UPDATE ON hostdependency
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  hostdependency_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM hostdependency;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT hostdependency_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/

CREATE OR REPLACE TRIGGER timeperiod_id_TRG BEFORE INSERT OR UPDATE ON timeperiod
FOR EACH ROW
DECLARE
v_newVal NUMBER(12) := 0;
v_incval NUMBER(12) := 0;
BEGIN
  IF INSERTING AND :new.id IS NULL THEN
    SELECT  timeperiod_id_SEQ.NEXTVAL INTO v_newVal FROM DUAL;
    -- If this is the first time this table have been inserted into (sequence == 1)
    IF v_newVal = 1 THEN
      -- get the max indentity value from the table
      SELECT NVL(max(id),0) INTO v_newVal FROM timeperiod;
      v_newVal := v_newVal + 1;
      -- set the sequence to that value
      LOOP
           EXIT WHEN v_incval>=v_newVal;
           SELECT timeperiod_id_SEQ.nextval INTO v_incval FROM dual;
      END LOOP;
    END IF;
    -- used to emulate LAST_INSERT_ID()
    -- mysql_utilities.identity := v_newVal;
   -- assign the value from the sequence to emulate the identity column
   :new.id := v_newVal;
  END IF;
END;

/
