<?php
/*
 * exports from the monitor database to the statistics database.
 *
 * Copyright(C) 2007 op5 AB
 * All rights reserved.
 *
 * TODO
 *  - Add import thingie.
 *
 */

require_once('classes/common_gui.php');
require_once('include/webconfig.inc.php');
require_once('include/objlock.inc.php');

$page->html_start();

die_if_locked_hard();

$st_db = false; # database handle for the statistics database
$st_db = mysql_pconnect('localhost', 'stats', 'stats');
if($st_db === false || (mysql_select_db('statistics', $st_db)) === false)
{
	echo "op5 Statistics is not installed.<br />\n";
	$page->html_end();
}

$st_templates = array();
#echo "Established connection with statistics database.<br />\n";
$result = mysql_query('SELECT id, name FROM host_template', $st_db);
while($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$st_templates[$row['id']] = $row['name'];
}

function exp_present_question()
{
	global $st_templates;
	global $Object_Index_Table, $page;
	global $st_db;

	$page->form_start();

	echo "<h2>Export to Statistics, step 1</h2>\n";

	# give a few notices of what we're going to do.
	echo "<p><strong>Note:</strong> This function will only export the basic host-information " .
	  "to the op5 Statistics configuration database, such as hostname and address.\n";
	echo "You will need to add graph-items and such from the statistics configuration interface</p></div><div style='clear:both'></div>\n";

	echo '<table style="margin-top: 15px; width: 100%; border-spacing: 0px; border-right: 1px solid #dcdcdc; border-collapse: collapse">'."\n";
	echo '<tr><th colspan="2" style="text-align: left; padding-left: 7px">Export to Statistics</th></tr>';

	# pick an snmp community (use default from statistics.settings)
	$result = mysql_query('SELECT value FROM settings WHERE name = "snmp_community"');
	if(!$result || !($snmp_community = mysql_fetch_row($result))) {
		$snmp_community = 'public';
	}
	else {
		$snmp_community = $snmp_community[0];
	}

	echo "<tr class='even'><td style='padding-left: 7px; width: 202px'>\n";
	echo "SNMP Community</td>";
	echo "<td><input type='text' name='snmp_community' value='$snmp_community'></td>\n";
	echo "</tr>\n";

	# print the selection of available host templates
	echo "<tr class='odd'><td style='padding-left: 7px'>\n";
	echo "Host template to use for exported hosts";
	echo "</td><td>\n";
	$page->make_selection($st_templates, false, 'statistics_host_template');
	echo "</tr>\n";

	echo "<tr class='even'><td style='padding-left: 7px'>\n";
	echo "op5 Monitor host identifier to use for Statistics 'Host Description' field ";
	echo "</td><td>\n";
	echo "<select name='name_or_alias'>\n";
	echo "  <option 'host_name'>host_name</option>\n";
	echo "  <option 'alias'>alias</option>\n";
	echo "  <option 'combo'>host_name / alias</option>\n";
	echo "</select><br />\n";
	echo "</td></tr>\n";
	echo "</table>\n";

	# fetch hosts and print out the selection.
	$i = 0;
	$hosts = array();
	$host_match = array();
	$legal_hosts = get_objects_for_user('host');
	$result = pdo_exec_query('SELECT id, address, alias, host_name FROM host WHERE register != 0 ORDER BY host_name');
	while($ary = $result->fetch(PDO::FETCH_ASSOC)) {
		if (isset($legal_hosts[$ary['id']])) {
			$hosts[$ary['id']] = $ary['host_name'] . ' / ' . $ary['alias'];
			$host_match[$i++] = $ary;
		}
	}
	unset($result);

	echo '<table class="max">';
	echo '<tr class="odd"><td style="width: 190px">Hostgroups to export</td>';
	echo '<td style="border-right: 1px solid #cdcddc">';
	$hg_list = get_objects_for_user('hostgroup');
	$page->make_multi_selection($hg_list, false, 'selected_hostgroups');

	$result = mysql_query('SELECT description, hostname FROM host', $st_db);
	$st_hosts = array();
	while($ary = mysql_fetch_array($result)) {
		$st_hosts[$ary['description']] = $ary['hostname'];
	}

	# slow and stupid matching, but we've got to do something like it
	foreach($host_match as $k => $ary) {
		if(isset($st_hosts[$ary['host_name']]) ||
		   isset($st_hosts[$ary['alias']]) ||
		   isset($st_hosts[$ary['host_name'] . ' / ' . $ary['alias']]) ||
		   isset($st_hosts[$ary['address']]) ||
		   in_array($ary['address'], $st_hosts))
		{
			unset($hosts[$ary['host_name']]);
		}
	}
	echo '</td></tr>';
	echo '<tr class="even"><td>Hosts to export</td>';
	echo '<td style="border-right: 1px solid #cdcddc">';
	$page->make_multi_selection($hosts, false, 'selected_hosts');
	echo '</td></tr>';
	echo '<tr class="button"><td style="border-top: 1px solid #cdcddc; padding-top: 7px" colspan="2">';
	$page->hidden_var('action', 'step2');
	$page->submit_button('Export hosts', 'x');
	echo '</td></tr>';
	echo '</table>';

	$page->form_end();
}

# We shamelessly borrow from the statistics API here.
$local_cacti_path = '/opt/statistics';
require_once($local_cacti_path . '/include/config.php');
require_once($local_cacti_path . '/include/global.php');
require_once($local_cacti_path . '/lib/utility.php');
require_once($local_cacti_path . '/lib/api_data_source.php');
require_once($local_cacti_path . '/lib/api_graph.php');
require_once($local_cacti_path . '/lib/snmp.php');
require_once($local_cacti_path . '/lib/data_query.php');
require_once($local_cacti_path . '/lib/api_device.php');
require_once($local_cacti_path . '/lib/database.php');
define("MAX_DISPLAY_PAGES", 21);

function exp_export_hosts()
{
	global $DEBUG, $page;
	global $st_db;
	global $db, $input;

	$statistics_host_template = false;
	$name_or_alias = 'host_name';
	$hosts_to_export = false;

	# defaults, in case we can't get the settings
	# from neither user nor database
	$snmp_community = 'public';
	$id = 0;
	$snmp_ver = 1;
	$snmp_port = 161;
	$snmp_timeout = 1000;
	$snmp_password = $snmp_username = '';
	$availability_method=1;
	$ping_method=1;
	$ping_port=0;
	$ping_timeout=500;
	$ping_retries=1;
	$notes=null;
	$snmp_auth_protocol=null;
	$snmp_priv_passphrase=null;
	$snmp_priv_protocol=null;
	$snmp_context=null;
	$max_oids=10;
	$disabled=null;

	# Try and get defaults from statistics settings
	if (($result = mysql_query('SELECT * FROM settings', $st_db))) {
		while ($ary = mysql_fetch_array($result, MYSQL_ASSOC)) {
			$k = $ary['name'];
			$value = $ary['value'];
			switch ($ary['name']) {
			 case 'snmp_community':
			 case 'snmp_password': case 'snmp_username': case 'snmp_port':
			 case 'snmp_retries': case 'snmp_timeout': case 'snmp_ver':
			 case 'ping_method': case 'ping_port': case 'ping_timeout':
			 case 'ping_retries':
			 case 'availability_method':
				# polymorphic variables have their uses, I guess
				$$k = $value;
				break;
			}
		}
	}

	if(!empty($_REQUEST['name_or_alias']))
	  $name_or_alias = str_replace(' /', ',', $_REQUEST['name_or_alias']);

	$hosts_to_export = array_pop($input->selection);

	if (empty($hosts_to_export)) {
		echo "<p>No hosts selected to export</p>\n";
		exp_present_question();
		return;
	}

	if(!empty($_REQUEST['statistics_host_template']))
	  $statistics_host_template = $_REQUEST['statistics_host_template'];
	else {
		echo "<p>You just made an impossible selection. I'm not stupid you know.</p>\n";
		$page->html_end();
	}

	if(!empty($_REQUEST['snmp_community']))
	  $snmp_community = $_REQUEST['snmp_community'];

	# make sure we behave somewhat cleverly in case people press reload
	$st_host_list = array();
	$result = mysql_query('SELECT description, hostname FROM host', $st_db);
	while($ary = mysql_fetch_array($result, MYSQL_ASSOC)) {
		$st_host_list[] = array('hostname' => $ary['hostname'], 'description' => $ary['description']);
	}

	$query = "SELECT $name_or_alias, address FROM host WHERE id = ";
	$query .= implode(' OR id = ', $hosts_to_export);

	$result = pdo_exec_query($query);

	$export_list = array();
	$i = 0;
	while($ary = $result->fetch(PDO::FETCH_ASSOC)) {
		$descr = implode(' / ', $ary);
		
		foreach ($st_host_list as $st_obj) {
			if ($st_obj['hostname'] === $ary['address']) {
				echo "A host with address " . $ary['address'] .
				  " is already configured in statistics.<br />\n";
				continue 2;
			}
			if($st_obj['description'] === $descr) {
				echo "A host with description " . $descr .
				  " is already configured in statistics.<br />\n";
				continue 2;
			}
		}

		# copy address and unset it, so we can implode the description
		$export_list[$i]['hostname'] = $ary['address'];
		unset($ary['address']);

		# set description
		$export_list[$i]['description'] = $descr;

		$i++;
	}
	unset($result);

	$query_head = false;
	$fail = $succ = 0;

	$result = mysql_query('SELECT id FROM statistics.host ORDER BY id DESC LIMIT 1', $st_db);
	if ($result) {
		$row = mysql_fetch_row($result);
		$id = $row[0] + 1;
	}
	else {
		echo "Failed to fetch host ID to use in statistics database: " . mysql_error() . "<br />\n";
		echo "Aborting<br />\n";
		$page->html_end();
	}
	foreach ($export_list as $ary) {
		$host_template_id = $statistics_host_template;
		$hostname = $ary['hostname'];
		$description = $ary['description'];


		# shove it into the cacti api for processing
		$host_id = api_device_save($id, $host_template_id,
								   $description, $hostname,
								   $snmp_community, $snmp_ver,
								   $snmp_username, $snmp_password,
								   $snmp_port, $snmp_timeout, $disabled,
								   $availability_method, $ping_method,
								   $ping_port, $ping_timeout, $ping_retries,
								   $notes, $snmp_auth_protocol, $snmp_priv_passphrase,
								   $snmp_priv_protocol, $snmp_context, $max_oids);

		if (is_error_message()) {
			echo "Failed to export $description.<br />\n";
			$fail++;
		}
		else {
			echo "Successfully exported $description.<br />\n";
			$succ++;
		}
		$id++;
	}

	if($succ) echo "$succ hosts successfully exported.<br />\n";
	if($fail) echo "Failed to export $fail hosts<br />\n";
	echo "</p>\n";
}


if(empty($_REQUEST['action'])) exp_present_question();
else if($_REQUEST['action'] === 'step2') {
	exp_export_hosts();
}
else {
	echo "<p>It appears you have managed to feed me some illegal input.</p>\n";
#	echo "<pre>\n"; print_r($_REQUEST); echo "</pre>\n";
}
echo '</div>';

$page->html_end();
