<?php

require_once('base_widget.php');
require_once('select.php');
require_once('string.php');

/**
 * String widget, with a list of common shortcuts for action_url paths
 */
class actionurl_widget extends base_widget {
	/**
	 * List of url shortcuts
	 */
	var $protocols = array(
		'' => '',
		'telnet://$HOSTADDRESS$' => 'telnet',
		'http://$HOSTADDRESS$' => 'http',
		'https://$HOSTADDRESS$' => 'https',
		'ftp://$HOSTADDRESS$' => 'ftp',
		'ssh://$HOSTADDRESS$' => 'ssh',
		'rdp://$HOSTADDRESS$' => 'rdp',
	);

	function render($obj, $token, $value) {
		$this->string = new string_widget();
		select_widget::make_selection($this->protocols, $value, "$obj->type[$obj->id][$token][select]", $obj->id);
		$this->string->render($obj, $token . '][string', $value);
		echo "<script type=\"text/javascript\">
			$('select[name=$obj->type\\\\[$obj->id\\\\]\\\\[$token\\\\]\\\\[select\\\\]]').change(function() {
				$('input[name=$obj->type\\\\[$obj->id\\\\]\\\\[$token\\\\]\\\\[string\\\\]]')[0].value = this.value;
			});
			$('input[name=$obj->type\\\\[$obj->id\\\\]\\\\[$token\\\\]\\\\[string\\\\]]').keydown(function() {
				$('select[name=$obj->type\\\\[$obj->id\\\\]\\\\[$token\\\\]\\\\[select\\\\]]')[0].value = '';
			});
		</script>";
	}

	static function validate($obj, $token, $value) {
		# normal case
		if (is_array($value)) {
			$res = string_widget::validate($obj, $token, $value['string']);
			if (!$res)
				$res = select_widget::validate($obj, $token, $value['select']);
		}
		# if we call validate twice (host_wizard does), this will already be a string
		else {
			$res = string_widget::validate($obj, $token, $value);
		}
		return $res;
	}
}
