<?php

require_once('base_widget.php');

/**
 * Widget for generating a set of checkboxes
 */
class checkbox_widget extends base_widget {
	function render($obj, $token, $value) {
		$options = $obj->properties['special'][$token];
		$obj_val = $value;
		$name = $this->get_id($obj, $token);

		if (!is_array($obj_val)) {
			$cur = explode(',', $obj_val);
		} else {
			if (count($obj_val) > 1 && isset($obj_val['n']))
			  unset($obj_val['n']);

			$cur = array_keys($obj_val);
		}

		echo "<table class='box-table'>\n";
		foreach($options as $opt => $opt_str) {
			if($opt_str === false) {
				$default_name = $name.'['.$opt.']';
				if (!empty($obj->obj['template'])) {
					$tmpl_class = $obj->db_table . '_template_class';
					$tmpl = new $tmpl_class($obj->obj['template']);
					if (isset($tmpl->obj[$token]))
						$default_value = $tmpl->obj[$token] != $opt;
					else
						$default_value = !isset($obj->nagios_defaults[$token][$opt]);
				} else {
					$default_value = !isset($obj->nagios_defaults[$token][$opt]);
				}
				echo "   <input type='hidden' name='$default_name' value='$default_value' />\n";
				continue;
			}

			$id = preg_replace('/[^a-z0-9]+/', '_', strtolower($name).'_'.$opt);
			$id = trim($id, '_');
			echo "<tr>\n";
			printf("  <td class=\"checkbox\"><input id='%s' type='checkbox' name='%s[%s]' %s class=\"auto\" />\n",
				$id,
				$name,
				$opt,
				in_array($opt, $cur) ? "checked='checked'" : "");
			echo "  </td>\n";
			echo "  <td><label for='$id'>$opt_str</label></td>\n</tr>";
		}
		echo "</table>\n";
	}

	static function validate($obj, $token, $value) {
		$spec = $obj->properties['special'];
		if (is_array($value))
			$cb_var = array_keys($value);
		else
			$cb_var = preg_split("/,[ \t]*/", $value);
		foreach ($cb_var as $cb) {
			if (!isset($spec[$token][$cb])) {
				throw new widget_validation_exception(
					"Illegal checkbox option. Only " .
					join(', ', array_keys($spec[$token])) . " are valid");
				break;
			}
		}
		return $value;
	}
}
