<?php

require_once('base_widget.php');

/**
 * Widget that only accepts numeric values
 */
class int_widget extends base_widget {
	function render($obj, $token, $value) {
		echo "<input type='text' name='" . $this->get_id($obj, $token) ."' id='" .
			$this->get_id($obj, $token) ."' value='" . $value . "' size='10' />\n";
	}

	static function validate($obj, $token, $value) {
		$nzints = array('max_check_attempts' => 1);
		if ($obj->type === 'service')
			$nzints['retry_interval'] = 1;

		if ($value !== 'new' && !is_numeric($value) || intval($value) < 0)
			throw new widget_validation_exception('Requires positive integer value');
		elseif (isset($nzints[$token]) && intval($value) === 0)
			throw new widget_validation_exception('Requires positive non-zero integer value');
		return (string)$value;
	}
}
