<?php

require_once('base_widget.php');

/**
 * Widget for printing a dropdown list for single object select
 */
class select_widget extends base_widget {
	static private $printed_buttons = 0;
	static private $printed_filterobjs = 0;
	/**
	 * Add filter list buttons (to something)
	 * @param $size Unused, but must be greater than 3 !FIXME!
	 */
	public static function addFilterlistButtons($size=0)
	{
		$size = (int)$size;
		if ($size < 3) {
			return false;
		}
		?>
		<input name="regexp<?php echo ++self::$printed_buttons ?>" id="regexp<?php echo self::$printed_buttons ?>" class="small" autocomplete="off" value="Filter by regular expression" onfocus="if(this.value == 'Filter by regular expression') { this.value=''; this.style.color = '#000000' }"  onblur="if(this.value=='') { this.value='Filter by regular expression'; this.style.color = '#777777'; }" style="color: #777777" />
		<input type="button" onclick="$('#regexp<?php echo self::$printed_buttons ?>').val('').trigger('blur').trigger('keyup')" value="Clear" title="Clear" />
		<?php
	}

	/**
	 * Add a filter list to (something)
	 * @param $select_name Name of the form variable
	 * @param $size Unused, but must be greater than 3 !FIXME!
	 * @param $extra_select Name of a select containing more variables
	 */
	public static function addFilterlist($select_name='obj_id', $size=0, $extra_select=false)
	{
		$select_name = trim($select_name);
		$size = (int)$size;
		if ($select_name==='' || $size<3){
			return false;
		}
		$filter_id = ++self::$printed_filterobjs;
		?><script type="text/javascript">
		<!--
		var filter<?php echo $filter_id; ?> = new filterlist($('select[name="<?php echo $select_name ?>"]')[0]<?php echo ($extra_select ? ', $(\'select[name="'.$extra_select.'"]\')[0]' : ''); ?>);
		var filter<?php echo $filter_id; ?>_timeout;
		var filter<?php echo $filter_id; ?>_val;
		$('#regexp<?php echo self::$printed_buttons; ?>').keyup(function(ev) {
			clearTimeout(filter<?php echo $filter_id; ?>_timeout);
			var current_value = this.value;
			filter<?php echo $filter_id; ?>_timeout = setTimeout(function() {
				if(current_value === filter<?php echo $filter_id; ?>.pattern) {
					return;
				}
				filter<?php echo $filter_id; ?>.hook = function() {
					filter<?php echo $filter_id; ?>_val = current_value;
				};
				filter<?php echo $filter_id; ?>.set(current_value);
			}, 1000);
		});
		//-->
		</script>
		<?php
	}

	/**
	 * Makes a selection of the items in the indexed array $tokenvalues, using $dflt
	 * as default selection, with a(form) 'name' of $select_name */
	public static function make_selection($tokenvalues, $dflt, $select_name = 'selection', $class_name = 'xlarge') {
		global $master_obj; # host and servicedependencies set this
		global $DEBUG;
		$noprint = false;

		if(func_num_args() > 3) {
			$noprint = func_get_arg(3);
		}

		/* if array is empty, we tell the user so */
		if(empty($tokenvalues) || !is_array($tokenvalues) || !count($tokenvalues)) {
			echo "None configured\n";
			return(true);
		}

		// this is necessary for us to handle the FILE's in default lists.
		if($dflt !== '' && !is_numeric($dflt) && !is_int($dflt)) {
			if(in_array($dflt, $tokenvalues)) {
				$dflt = array_search($dflt, $tokenvalues);
			}
		}

		if(count($tokenvalues) === 1) foreach($tokenvalues as $k => $v) {
			if($v === false && $k === 0) {
				echo "None configured\n";
				return(true);
			}
		}

		if ($select_name == 'obj_id')
			echo "\n<select name='$select_name' id='$select_name'>\n";
		else
			echo "\n<select name='$select_name' id='$select_name' class=\"$class_name\">\n";

		if(isset($tokenvalues[0])) {
			echo "  <option value='0'>&nbsp;</option>\n";
			unset($tokenvalues[0]);
		}
		foreach($tokenvalues as $k => $v) {
			if($k == $dflt)
			  echo "  <option selected='selected' value='".gui_class::escape_html($k)."'>".gui_class::escape_html($v)."</option>\n";
			else
			  echo "  <option value='".gui_class::escape_html($k)."'>".gui_class::escape_html($v)."</option>\n";
		}
		echo "</select>\n";

		return true;
	}

	function render($obj, $token, $value) {
		if(is_array($obj->properties['special'][$token]))
			$sel_tmp = $obj->properties['special'][$token];
		else
			$sel_tmp = get_objects_for_user($obj->properties['special'][$token]);

		# If this variable isn't required, add an empty
		# item to the selection list.
		if (!(in_array($token, $obj->properties['required']) && !isset($obj->properties['req_alt'][$token])) && !empty($sel_tmp))
			$sel_tmp[0] = '';

		if (($obj->type==='service' || $obj->type==='host' || $obj->type==='servicedependency') && ($token==='check_command' || $token === 'service')){
			self::addFilterlistButtons(10);
		}

		if (!$value || isset($sel_tmp[$value]) || in_array($value, $sel_tmp) || !$obj->id || $obj->id == 'new' || substr($obj->type, 0, 3) == 'new') {
			self::make_selection($sel_tmp, $value,
					   $this->get_id($obj, $token),
					   $obj->id);
		} else {
			# The user isn't allowed to change the value. If the user
			# modifies it, it will just be reverted server-side, so
			# don't even print a select box.
			$objects = get_object_index_table($obj->properties['special'][$token]);
			if (isset($objects[$value])) {
				echo gui_class::escape_html($objects[$value]);
			} else {
				echo gui_class::escape_html($value);
			}
			echo "  <input type=\"hidden\" name=\"" . $this->get_id($obj, $token) . "\" id=\"" . $this->get_id($obj, $token) . "\" value=\"" .  gui_class::escape_html($value) . "\" />\n";
		}
		if ($token==='check_command'){
			echo "<input type=\"button\" class=\"button syntax-help20\" id=\"syntax_button\" value=\"Syntax help\" title=\"Show syntax help for selected command\" onclick=\"toggle_command_info(this.form, '', '".$obj->id."', true);\">";
			echo "<input type=\"button\" class=\"button edit-check-command20\" title=\"Edit selected Check Command\" onclick=\"return editCheckCommand(this.form);\" value=\"Edit check command\">";
			echo "<div id=\"commandInfo\"></div>";
			self::addFilterlist($this->get_id($obj, $token), 10);
		} elseif ($obj->type==='servicedependency' && $token === 'service') {
			self::addFilterlist($this->get_id($obj, $token), 10);
		}
		if ($token === 'template') {
			echo '<input type="button" class="button force_template_btn" value="Force template values" title="Force values from template to current object" />';
			echo ' <input type="button" class="show_template_values_btn button" value="View template values" title="View template values for current object" />';
			if(!isset($sel_tmp[$value])) {
				return;
			}
			printf(' (current template: <span id="current_template">%s</span>)', $sel_tmp[$value]);
		}
	}

	static function validate($obj, $token, $value) {
		$spec = $obj->properties['special'];
		$req_vars = $obj->properties['required'];
		// special case for 'not selected' or if object is array
		if (($value === '0' && !in_array($value, $req_vars)) || is_array($spec))
			return $value;
		if (!self::object_exists($spec, $obj->obj[$token]))
			throw new widget_validation_exception("Supposed to link to {$spec[$token]} type object, but the object linked to doesn't exist");
		return $value;
	}
}
