#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-

def do_nacoma(args):
    if(len(args) < 2):
        sys.stderr.write("usage: check_mk --nacoma inventory <hostname>\n");
        sys.exit(1);
    if(args[0] == "inventory"):
        get_inventory(args[1]);
    else:
        sys.stderr.write("unknown option: %s\n" % args);
        sys.exit(1);
    sys.exit(0);

def get_inventory(hostname):
    try:
        ipaddress = lookup_ipaddress(hostname)
        output = get_agent_info(hostname, ipaddress, 0)
        if len(output) == 0:
            raise MKAgentError("Empty output from agent")
        elif len(output) < 16:
            raise MKAgentError("Too short output from agent: '%s'" % output)

        lines = [ l.strip() for l in output.split('\n') ]
        info = parse_info(lines)

        for ct in inventorable_checktypes():
            checkname_base = ct.split('.')[0]    # make e.g. 'lsi' from 'lsi.arrays'
            if not info.has_key(checkname_base):
                continue
            try:
                inventory_function = check_info[ct][3]
                inventory = inventory_function(ct, info[checkname_base]) # inventory is a list of pairs (item, current_value)
                for entry in inventory:
                    if len(entry) == 2: # comment is now obsolete
                        item, paramstring = entry
                    else:
                        item, comment, paramstring = entry
                    description = service_description(ct, item)
                    print '%s|%s|%s|%s' % (description, ct, item, paramstring)
            except Exception, e:
                sys.stderr.write("%s: Invalid output from agent or invalid configuration: %s\n" % (hostname, e))
                continue

    except MKAgentError, e:
        sys.stderr.write("Host '%s': %s\n" % (hostname, str(e)))
        sys.exit(1)
    except Exception, e:
        sys.stderr.write("Cannot get information from host '%s': %s\n" % (hostname, e))
        sys.exit(1)

    except KeyboardInterrupt:
        sys.stderr.write('<Interrupted>\n')
        sys.exit(1)
    sys.exit(0)
